.486
.model flat, stdcall
option casemap: none

; API functions
; ------------------------------------------------------------------------------
include  \masm32\include\windows.inc
include  \masm32\include\user32.inc
include  \masm32\include\kernel32.inc
include  \masm32\include\comctl32.inc
include  \masm32\include\masm32.inc

includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\comctl32.lib
includelib  \masm32\lib\masm32.lib


; Prototype 
; ************************************
DialogProc PROTO : HWND, : UINT, : WPARAM, : LPARAM

.const
; Resource ids
; ************************************
IDD_DLG1  	  equ 101
IDI_ICON      equ 200
IDC_EXIT      equ 102
IDC_LST1      equ 103
IDS_STRINGID  equ 10
IDS_STRINGID1 equ 20

; Required data
; ************************************
.data
szTitle    db 'STRINGTABLE Example', 0
szBuffer   db 100 dup(0)
szBuffer1  db 100 dup(0)


.data?
hInstance HINSTANCE ?
hIcon     HICON     ?
hListBox  dd ?

.code

start:

INVOKE InitCommonControls

INVOKE GetModuleHandle, NULL
mov hInstance, eax

INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax

INVOKE DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, 0
INVOKE ExitProcess, 0


; Dialog procedure
; ************************************
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM

 .IF uMsg == WM_INITDIALOG
 
  INVOKE SetWindowText, hWnd, addr szTitle 
  INVOKE SendMessage, hWnd, WM_SETICON,ICON_SMALL, hIcon
  ; initialising our List box
  INVOKE GetDlgItem,hWnd,103 ;Windows API result gets stored in eax
   mov hListBox, eax ; flag from eax moved to hListBox
   
  INVOKE LoadString,hInstance ,IDS_STRINGID,offset szBuffer,(sizeof szBuffer)/2 ; Load Sting # 10 in the rsrc.rc
  INVOKE LoadString,hInstance ,IDS_STRINGID1,offset szBuffer1,(sizeof szBuffer1)/2 ; Load Sting # 20 in the rsrc.rc
  INVOKE SendMessage,hListBox,LB_ADDSTRING,NULL,offset szBuffer ; add string # 10 to a list box 
  
 .ELSEIF uMsg == WM_COMMAND
   
 .ELSEIF uMsg == WM_SETCURSOR
 
INVOKE GetDlgCtrlID, wParam
  .IF eax == IDC_EXIT
 INVOKE SendMessage,hListBox,LB_ADDSTRING,NULL,offset szBuffer1 ; add string # 20 to a list box 
  ret
  .ENDIF    

   .ELSEIF uMsg == WM_CLOSE
    INVOKE EndDialog, hWnd, 0
 .ENDIF

  
  .IF wParam == IDC_EXIT 
    INVOKE SendMessage, hWnd, WM_CLOSE, 0, 0

    .ENDIF

    xor eax,eax
  ret
DialogProc endp

end start